;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SYSSTRINGLENGTH	EQU	118
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysDivLoop	EQU	116
SysStringA	EQU	119
SysStringA_H	EQU	120
SysStringB	EQU	114
SysStringB_H	EQU	115
SysWaitTemp10US	EQU	117
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
SysWaitTempS	EQU	116
SysWaitTempUS	EQU	117
SysWaitTempUS_H	EQU	118
SYSSTRINGPARAM1	EQU	169
DataPointer	EQU	32
SOUNDPLAYBYTE	EQU	33
SOUNDPLAYBYTES	EQU	34
SOUNDPLAYCHECKCOMMAND	EQU	35
SOUNDPLAYCOMMAND	EQU	36
SOUNDPLAYCURRNOTE	EQU	37
SOUNDPLAYCYCLES	EQU	38
SOUNDPLAYCYCLES_H	EQU	39
SOUNDPLAYDOTS	EQU	40
SOUNDPLAYLENGTH	EQU	41
SOUNDPLAYNOTE	EQU	42
SOUNDPLAYNOTELEN	EQU	43
SOUNDPLAYNOTETYPE	EQU	44
SOUNDPLAYNUMBER	EQU	45
SOUNDPLAYOCTAVE	EQU	46
SOUNDPLAYPERIOD	EQU	47
SOUNDPLAYTEMP	EQU	48
SOUNDPLAYTEMPO	EQU	49
StringPointer	EQU	50
SysRepeatTemp1	EQU	51
SysRepeatTemp1_H	EQU	52
SysRepeatTemp2	EQU	53
SysSOUNDPLAYDATAHandler	EQU	54
SysSOUNDPLAYDATAHandler_H	EQU	55
SysTemp1	EQU	56
SysTemp1_H	EQU	57
SysTemp2	EQU	58
SysTemp2_H	EQU	59

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
	call	INITSOUNDPLAY

;Start of the main program
;Play music on a piezo connected to GP0.
;Alternatively, you could connect GP0 to the line
;output and drive an external speaker or amplifier and then
;use the volume control to tame things as required.
;----- Settings
;----- Constants
;#define SOUNDOUT GPIO.0				;piezo on pin 7
;----- Program
;dir SOUNDOUT out							;set as output
	banksel	TRISIO
	bcf	TRISIO,0
;do
SysDoLoop_S1
;play	"T240"								;The song data follows the
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable1
	movwf	SysStringA
	movlw	high StringTable1
	movwf	SysStringA_H
	banksel	STATUS
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"O1C2O0B4.O1C8O0A4O1"	;QBasic format, but none of
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable2
	movwf	SysStringA
	movlw	high StringTable2
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"C2D4E-4E4F4F#4G4P4"	;the M commands are
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable3
	movwf	SysStringA
	movlw	high StringTable3
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"O0G2O3E4P8E8E4E4E4"	;supported.
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable4
	movwf	SysStringA
	movlw	high StringTable4
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"8E8F4F4D8C#8D8E8D4"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable5
	movwf	SysStringA
	movlw	high StringTable5
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"D4O3C32O2B16.B8A4B4"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable6
	movwf	SysStringA
	movlw	high StringTable6
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"G4O3G4P8G8G4G4O3G4"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable7
	movwf	SysStringA
	movlw	high StringTable7
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"P8G8G#4G#4A8G#8A8O4"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable8
	movwf	SysStringA
	movlw	high StringTable8
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"C8O3B4A4G#2.O3G#4G4"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable9
	movwf	SysStringA
	movlw	high StringTable9
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"P8G8O4C4P8O3A8G4F#4"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable10
	movwf	SysStringA
	movlw	high StringTable10
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"G4E4D4O2G8F#8G4O3D4"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable11
	movwf	SysStringA
	movlw	high StringTable11
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"O2G8F#8G4O3O3G4P8G8"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable12
	movwf	SysStringA
	movlw	high StringTable12
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"O4C4P8O3A8G4F#4G4"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable13
	movwf	SysStringA
	movlw	high StringTable13
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"E-4D4O2F#8E8F#8E8"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable14
	movwf	SysStringA
	movlw	high StringTable14
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"F#4G4P4G4.F8E2A4.G8"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable15
	movwf	SysStringA
	movlw	high StringTable15
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"O1B2A2O1G2O2F2E2D4."
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable16
	movwf	SysStringA
	movlw	high StringTable16
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"E8F4A2O3C4D2C2O2E1"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable17
	movwf	SysStringA
	movlw	high StringTable17
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"D2O3G4.F8E2A4.G8O2"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable18
	movwf	SysStringA
	movlw	high StringTable18
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"B2A2G2O3F2E2D4.E8F4"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable19
	movwf	SysStringA
	movlw	high StringTable19
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"A4O4D4.C8O3E4G4C4."
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable20
	movwf	SysStringA
	movlw	high StringTable20
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;play	"E8D1C1"
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable21
	movwf	SysStringA
	movlw	high StringTable21
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysSOUNDPLAYDATAHandler_H
	call	PLAY
;wait 1 S										;pause a bit
	movlw	1
	movwf	SysWaitTempS
	call	Delay_S
;loop													;then repeat
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

Delay_S
DS_START
	movlw	232
	movwf	SysWaitTempMS
	movlw	3
	movwf	SysWaitTempMS_H
	call	Delay_MS
	decfsz	SysWaitTempS, F
	goto	DS_START
	return

;********************************************************************************

INITSOUNDPLAY
;SoundPlayOctave = 4
	movlw	4
	movwf	SOUNDPLAYOCTAVE
;SoundPlayLength = 4
	movlw	4
	movwf	SOUNDPLAYLENGTH
;SoundPlayTempo = 120
	movlw	120
	movwf	SOUNDPLAYTEMPO
;SoundPlayDots = 0
	clrf	SOUNDPLAYDOTS
;SoundPlayCommand = SOUND_CMD_NONE
	clrf	SOUNDPLAYCOMMAND
;Dir SOUNDOUT Out
	banksel	TRISIO
	bcf	TRISIO,0
	banksel	STATUS
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

PLAY
;SoundPlayNumber = 0
	clrf	SOUNDPLAYNUMBER
;SoundPlayBytes = SoundPlayData(0) + 1
	movf	SysSOUNDPLAYDATAHandler,W
	movwf	FSR
	bcf	STATUS, IRP
	btfsc	SysSOUNDPLAYDATAHandler_H,0
	bsf	STATUS, IRP
	incf	INDF,W
	movwf	SOUNDPLAYBYTES
;For SoundPlayCurrNote = 1 To SoundPlayBytes
	clrf	SOUNDPLAYCURRNOTE
	movlw	1
	subwf	SOUNDPLAYBYTES,W
	btfss	STATUS, C
	goto	SysForLoopEnd1
SysForLoop1
	incf	SOUNDPLAYCURRNOTE,F
;If SoundPlayCurrNote = SoundPlayBytes Then
	movf	SOUNDPLAYBYTES,W
	subwf	SOUNDPLAYCURRNOTE,W
	btfss	STATUS, Z
	goto	ELSE2_1
;SoundPlayByte = SOUND_CMD_NONE
	clrf	SOUNDPLAYBYTE
;Else
	goto	ENDIF2
ELSE2_1
;SoundPlayByte = SoundPlayData(SoundPlayCurrNote)
	movf	SOUNDPLAYCURRNOTE,W
	addwf	SysSOUNDPLAYDATAHandler,W
	movwf	FSR
	bcf	STATUS, IRP
	btfsc	SysSOUNDPLAYDATAHandler_H,0
	bsf	STATUS, IRP
	movf	INDF,W
	movwf	SOUNDPLAYBYTE
;End If
ENDIF2
;If SoundPlayByte >= "a" Then
	movlw	97
	subwf	SOUNDPLAYBYTE,W
	btfss	STATUS, C
	goto	ENDIF3
;If SoundPlayByte <= "z" Then
	movf	SOUNDPLAYBYTE,W
	sublw	122
	btfss	STATUS, C
	goto	ENDIF6
;SoundPlayByte -= 32
	movlw	32
	subwf	SOUNDPLAYBYTE,F
;End If
ENDIF6
;End If
ENDIF3
;If SoundPlayCheckCommand(SoundPlayByte) Then
	call	FN_SOUNDPLAYCHECKCOMMAND
	movf	SOUNDPLAYCHECKCOMMAND,F
	btfsc	STATUS,Z
	goto	ELSE4_1
;If SoundPlayCommand <> SOUND_CMD_NONE Then
	movf	SOUNDPLAYCOMMAND,F
	btfsc	STATUS, Z
	goto	ENDIF7
;If SoundPlayCommand >= "A" Then
	movlw	65
	subwf	SOUNDPLAYCOMMAND,W
	btfss	STATUS, C
	goto	ENDIF13
;If SoundPlayCommand <= "G" Then
	movf	SOUNDPLAYCOMMAND,W
	sublw	71
	btfss	STATUS, C
	goto	ENDIF23
;ReadTable SoundPlayNoteNumbers, SoundPlayCommand - 64, SoundPlayNote
	movlw	64
	subwf	SOUNDPLAYCOMMAND,W
	movwf	DataPointer
	call	SOUNDPLAYNOTENUMBERS
	movwf	SOUNDPLAYNOTE
;SoundPlayNote = SoundPlayOctave * 12 + SoundPlayNote
	movf	SOUNDPLAYOCTAVE,W
	movwf	SysCalcTempA
	movlw	12
	movwf	SysCalcTempB
	call	SysMultSub
	movf	SOUNDPLAYNOTE,W
	addwf	SYSCALCTEMPX,W
	movwf	SOUNDPLAYNOTE
;If SoundPlayNumber = 0 Then
	movf	SOUNDPLAYNUMBER,F
	btfss	STATUS, Z
	goto	ELSE28_1
;SoundPlayNoteLen = SoundPlayLength
	movf	SOUNDPLAYLENGTH,W
	movwf	SOUNDPLAYNOTELEN
;Else
	goto	ENDIF28
ELSE28_1
;SoundPlayNoteLen = SoundPlayNumber
	movf	SOUNDPLAYNUMBER,W
	movwf	SOUNDPLAYNOTELEN
;End If
ENDIF28
;If SoundPlayNoteType = SOUND_NOTE_FLAT Then
	movlw	2
	subwf	SOUNDPLAYNOTETYPE,W
	btfss	STATUS, Z
	goto	ENDIF29
;SoundPlayNote -= 1
	decf	SOUNDPLAYNOTE,F
;If SoundPlayNote = 0 Then
	movf	SOUNDPLAYNOTE,F
	btfss	STATUS, Z
	goto	ENDIF32
;SoundPlayNote = 1
	movlw	1
	movwf	SOUNDPLAYNOTE
;End If
ENDIF32
;End If
ENDIF29
;If SoundPlayNoteType = SOUND_NOTE_SHARP Then
	decf	SOUNDPLAYNOTETYPE,W
	btfss	STATUS, Z
	goto	ENDIF30
;SoundPlayNote += 1
	incf	SOUNDPLAYNOTE,F
;If SoundPlayNote = 85 Then
	movlw	85
	subwf	SOUNDPLAYNOTE,W
	btfss	STATUS, Z
	goto	ENDIF33
;SoundPlayNote = 84
	movlw	84
	movwf	SOUNDPLAYNOTE
;End If
ENDIF33
;End If
ENDIF30
;SoundPlayTone SoundPlayNote, SoundPlayNoteLen
	call	SOUNDPLAYTONE
;End If
ENDIF23
;End If
ENDIF13
;If SoundPlayCommand = "P" Then
	movlw	80
	subwf	SOUNDPLAYCOMMAND,W
	btfss	STATUS, Z
	goto	ENDIF14
;If SoundPlayNumber = 0 Then
	movf	SOUNDPLAYNUMBER,F
	btfss	STATUS, Z
	goto	ELSE24_1
;SoundPlayNoteLen = SoundPlayLength
	movf	SOUNDPLAYLENGTH,W
	movwf	SOUNDPLAYNOTELEN
;Else
	goto	ENDIF24
ELSE24_1
;SoundPlayNoteLen = SoundPlayNumber
	movf	SOUNDPLAYNUMBER,W
	movwf	SOUNDPLAYNOTELEN
;End If
ENDIF24
;SoundPlayTone 0, SoundPlayNoteLen
	clrf	SOUNDPLAYNOTE
	call	SOUNDPLAYTONE
;End If
ENDIF14
;If SoundPlayCommand = "N" Then
	movlw	78
	subwf	SOUNDPLAYCOMMAND,W
	btfss	STATUS, Z
	goto	ENDIF15
;SoundPlayTone SoundPlayNumber, SoundPlayLength
	movf	SOUNDPLAYNUMBER,W
	movwf	SOUNDPLAYNOTE
	movf	SOUNDPLAYLENGTH,W
	movwf	SOUNDPLAYNOTELEN
	call	SOUNDPLAYTONE
;End If
ENDIF15
;If SoundPlayCommand = "L" Then
	movlw	76
	subwf	SOUNDPLAYCOMMAND,W
	btfss	STATUS, Z
	goto	ENDIF16
;If SoundPlayNumber >= 1 Then
	movlw	1
	subwf	SOUNDPLAYNUMBER,W
	btfss	STATUS, C
	goto	ENDIF25
;If SoundPlayNumber <= 8 Then
	movf	SOUNDPLAYNUMBER,W
	sublw	8
	btfss	STATUS, C
	goto	ENDIF31
;SoundPlayLength = SoundPlayNumber
	movf	SOUNDPLAYNUMBER,W
	movwf	SOUNDPLAYLENGTH
;End If
ENDIF31
;End If
ENDIF25
;End If
ENDIF16
;If SoundPlayCommand = "T" Then
	movlw	84
	subwf	SOUNDPLAYCOMMAND,W
	btfss	STATUS, Z
	goto	ENDIF17
;If SoundPlayNumber >= 32 Then
	movlw	32
	subwf	SOUNDPLAYNUMBER,W
	btfss	STATUS, C
	goto	ENDIF26
;SoundPlayTempo = SoundPlayNumber
	movf	SOUNDPLAYNUMBER,W
	movwf	SOUNDPLAYTEMPO
;End If
ENDIF26
;End If
ENDIF17
;If SoundPlayCommand = "O" Then
	movlw	79
	subwf	SOUNDPLAYCOMMAND,W
	btfss	STATUS, Z
	goto	ENDIF18
;SoundPlayOctave = SoundPlayNumber
	movf	SOUNDPLAYNUMBER,W
	movwf	SOUNDPLAYOCTAVE
;End If
ENDIF18
;If SoundPlayCommand = "<" Then
	movlw	60
	subwf	SOUNDPLAYCOMMAND,W
	btfss	STATUS, Z
	goto	ENDIF19
;If SoundPlayOctave > 0 Then SoundPlayOctave -= 1
	movf	SOUNDPLAYOCTAVE,W
	sublw	0
	btfss	STATUS, C
	decf	SOUNDPLAYOCTAVE,F
;End If
ENDIF19
;If SoundPlayCommand = ">" Then
	movlw	62
	subwf	SOUNDPLAYCOMMAND,W
	btfsc	STATUS, Z
;SoundPlayOctave += 1
	incf	SOUNDPLAYOCTAVE,F
;End If
;If SoundPlayOctave > 6 Then SoundPlayOctave = 6
	movf	SOUNDPLAYOCTAVE,W
	sublw	6
	btfsc	STATUS, C
	goto	ENDIF21
	movlw	6
	movwf	SOUNDPLAYOCTAVE
ENDIF21
;End If
ENDIF7
;SoundPlayCommand = SoundPlayByte
	movf	SOUNDPLAYBYTE,W
	movwf	SOUNDPLAYCOMMAND
;SoundPlayNumber = 0
	clrf	SOUNDPLAYNUMBER
;SoundPlayNoteType = SOUND_NOTE_NORMAL
	clrf	SOUNDPLAYNOTETYPE
;SoundPlayDots = 0
	clrf	SOUNDPLAYDOTS
;Else
	goto	ENDIF4
ELSE4_1
;If SoundPlayByte >= "0" Then
	movlw	48
	subwf	SOUNDPLAYBYTE,W
	btfss	STATUS, C
	goto	ENDIF8
;If SoundPlayByte <= "9" Then
	movf	SOUNDPLAYBYTE,W
	sublw	57
	btfss	STATUS, C
	goto	ENDIF22
;SoundPlayNumber = SoundPlayNumber * 10 + SoundPlayByte - 48
	movf	SOUNDPLAYNUMBER,W
	movwf	SysCalcTempA
	movlw	10
	movwf	SysCalcTempB
	call	SysMultSub
	movf	SOUNDPLAYBYTE,W
	addwf	SYSCALCTEMPX,W
	movwf	SysTemp1
	movlw	48
	subwf	SysTemp1,W
	movwf	SOUNDPLAYNUMBER
;Goto SoundPlayNextNote
	goto	SOUNDPLAYNEXTNOTE
;End If
ENDIF22
;End If
ENDIF8
;If SoundPlayByte = "#" Then SoundPlayNoteType = SOUND_NOTE_SHARP
	movlw	35
	subwf	SOUNDPLAYBYTE,W
	btfss	STATUS, Z
	goto	ENDIF9
	movlw	1
	movwf	SOUNDPLAYNOTETYPE
ENDIF9
;If SoundPlayByte = "+" Then SoundPlayNoteType = SOUND_NOTE_SHARP
	movlw	43
	subwf	SOUNDPLAYBYTE,W
	btfss	STATUS, Z
	goto	ENDIF10
	movlw	1
	movwf	SOUNDPLAYNOTETYPE
ENDIF10
;If SoundPlayByte = "-" Then SoundPlayNoteType = SOUND_NOTE_FLAT
	movlw	45
	subwf	SOUNDPLAYBYTE,W
	btfss	STATUS, Z
	goto	ENDIF11
	movlw	2
	movwf	SOUNDPLAYNOTETYPE
ENDIF11
;If SoundPlayByte = "." Then SoundPlayDots += 1
	movlw	46
	subwf	SOUNDPLAYBYTE,W
	btfsc	STATUS, Z
	incf	SOUNDPLAYDOTS,F
;End If
ENDIF4
SOUNDPLAYNEXTNOTE
;Next
	movf	SOUNDPLAYBYTES,W
	subwf	SOUNDPLAYCURRNOTE,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
	return

;********************************************************************************

FN_SOUNDPLAYCHECKCOMMAND
;SoundPlayCheckCommand = TRUE
	movlw	255
	movwf	SOUNDPLAYCHECKCOMMAND
;If SoundPlayByte = SOUND_CMD_NONE Then Exit Function
	movf	SOUNDPLAYBYTE,F
	btfsc	STATUS, Z
	return
;If SoundPlayByte >= "A" Then
	movlw	65
	subwf	SOUNDPLAYBYTE,W
	btfss	STATUS, C
	goto	ENDIF39
;If SoundPlayByte <= "G" Then Exit Function
	movf	SOUNDPLAYBYTE,W
	sublw	71
	btfsc	STATUS, C
	return
;If SoundPlayByte = "L" Then Exit Function
	movlw	76
	subwf	SOUNDPLAYBYTE,W
	btfsc	STATUS, Z
	return
;If SoundPlayByte = "N" Then Exit Function
	movlw	78
	subwf	SOUNDPLAYBYTE,W
	btfsc	STATUS, Z
	return
;If SoundPlayByte = "O" Then Exit Function
	movlw	79
	subwf	SOUNDPLAYBYTE,W
	btfsc	STATUS, Z
	return
;If SoundPlayByte = "P" Then Exit Function
	movlw	80
	subwf	SOUNDPLAYBYTE,W
	btfsc	STATUS, Z
	return
;If SoundPlayByte = "T" Then Exit Function
	movlw	84
	subwf	SOUNDPLAYBYTE,W
	btfsc	STATUS, Z
	return
;End If
ENDIF39
;If SoundPlayByte = "<" Then Exit Function
	movlw	60
	subwf	SOUNDPLAYBYTE,W
	btfsc	STATUS, Z
	return
;If SoundPlayByte = ">" Then Exit Function
	movlw	62
	subwf	SOUNDPLAYBYTE,W
	btfsc	STATUS, Z
	return
;SoundPlayCheckCommand = FALSE
	clrf	SOUNDPLAYCHECKCOMMAND
	return

;********************************************************************************

SOUNDPLAYNOTENUMBERS
	movlw	8
	subwf	DataPointer, W
	btfsc	STATUS, C
	retlw	0
	movf	DataPointer, W
	addlw	1
	bcf	STATUS, C
	addlw	low TableSOUNDPLAYNOTENUMBERS
	movwf	DataPointer
	movlw	high TableSOUNDPLAYNOTENUMBERS
	btfsc	STATUS, C
	addlw	1
	movwf	PCLATH
	movf	DataPointer, W
TableSOUNDPLAYNOTENUMBERS
	movwf	PCL
	retlw	7
	retlw	10
	retlw	12
	retlw	1
	retlw	3
	retlw	5
	retlw	6
	retlw	8

;********************************************************************************

SOUNDPLAYNOTEPERIODS
	movlw	61
	subwf	DataPointer, W
	btfsc	STATUS, C
	retlw	0
	movf	DataPointer, W
	addlw	1
	bcf	STATUS, C
	addlw	low TableSOUNDPLAYNOTEPERIODS
	movwf	DataPointer
	movlw	high TableSOUNDPLAYNOTEPERIODS
	btfsc	STATUS, C
	addlw	1
	movwf	PCLATH
	movf	DataPointer, W
TableSOUNDPLAYNOTEPERIODS
	movwf	PCL
	retlw	60
	retlw	191
	retlw	180
	retlw	170
	retlw	161
	retlw	152
	retlw	143
	retlw	135
	retlw	128
	retlw	120
	retlw	114
	retlw	107
	retlw	101
	retlw	96
	retlw	90
	retlw	85
	retlw	80
	retlw	76
	retlw	72
	retlw	68
	retlw	64
	retlw	60
	retlw	57
	retlw	54
	retlw	51
	retlw	48
	retlw	45
	retlw	43
	retlw	40
	retlw	38
	retlw	36
	retlw	34
	retlw	32
	retlw	30
	retlw	28
	retlw	27
	retlw	25
	retlw	24
	retlw	23
	retlw	21
	retlw	20
	retlw	19
	retlw	18
	retlw	17
	retlw	16
	retlw	15
	retlw	14
	retlw	13
	retlw	13
	retlw	12
	retlw	11
	retlw	11
	retlw	10
	retlw	9
	retlw	9
	retlw	8
	retlw	8
	retlw	8
	retlw	7
	retlw	7
	retlw	6

;********************************************************************************

SOUNDPLAYTONE
;If SoundPlayNote = 0 Then
	movf	SOUNDPLAYNOTE,F
	btfss	STATUS, Z
	goto	ELSE34_1
;Wait 60000 / SoundPlayTempo * 4 / SoundPlayNoteLen ms
	movlw	96
	movwf	SysCalcTempA
	movlw	234
	movwf	SysCalcTempA_H
	movf	SOUNDPLAYTEMPO,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	SysTemp1
	movf	SysCalcTempA_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	4
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	SysTemp2
	movf	SysCalcTempX_H,W
	movwf	SysTemp2_H
	movf	SysTemp2,W
	movwf	SysCalcTempA
	movf	SysTemp2_H,W
	movwf	SysCalcTempA_H
	movf	SOUNDPLAYNOTELEN,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	SysWaitTempMS
	movf	SysCalcTempA_H,W
	movwf	SysWaitTempMS_H
	call	Delay_MS
;Else
	goto	ENDIF34
ELSE34_1
;SoundPlayTemp = SoundPlayNote
	movf	SOUNDPLAYNOTE,W
	movwf	SOUNDPLAYTEMP
;If SoundPlayTemp > 24 Then SoundPlayTemp -= 24
	sublw	24
	btfsc	STATUS, C
	goto	ENDIF35
	movlw	24
	subwf	SOUNDPLAYTEMP,F
ENDIF35
;ReadTable SoundPlayNotePeriods, SoundPlayTemp, SoundPlayPeriod
	movf	SOUNDPLAYTEMP,W
	movwf	DataPointer
	call	SOUNDPLAYNOTEPERIODS
	movwf	SOUNDPLAYPERIOD
;Dim SoundPlayCycles As Word
;SoundPlayCycles = 60000 / SoundPlayTempo
	movlw	96
	movwf	SysCalcTempA
	movlw	234
	movwf	SysCalcTempA_H
	movf	SOUNDPLAYTEMPO,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	SOUNDPLAYCYCLES
	movf	SysCalcTempA_H,W
	movwf	SOUNDPLAYCYCLES_H
;If SoundPlayNote > 24 Then
	movf	SOUNDPLAYNOTE,W
	sublw	24
	btfsc	STATUS, C
	goto	ELSE36_1
;SoundPlayCycles = SoundPlayCycles * 20 / SoundPlayNoteLen / SoundPlayPeriod * 10
	movf	SOUNDPLAYCYCLES,W
	movwf	SysCalcTempA
	movf	SOUNDPLAYCYCLES_H,W
	movwf	SysCalcTempA_H
	movlw	20
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	SysCalcTempX_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movf	SOUNDPLAYNOTELEN,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	SysTemp2
	movf	SysCalcTempA_H,W
	movwf	SysTemp2_H
	movf	SysTemp2,W
	movwf	SysCalcTempA
	movf	SysTemp2_H,W
	movwf	SysCalcTempA_H
	movf	SOUNDPLAYPERIOD,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	SysTemp1
	movf	SysCalcTempA_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	10
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	SOUNDPLAYCYCLES
	movf	SysCalcTempX_H,W
	movwf	SOUNDPLAYCYCLES_H
;Else
	goto	ENDIF36
ELSE36_1
;SoundPlayCycles = SoundPlayCycles * 5 / SoundPlayNoteLen / SoundPlayPeriod * 10
	movf	SOUNDPLAYCYCLES,W
	movwf	SysCalcTempA
	movf	SOUNDPLAYCYCLES_H,W
	movwf	SysCalcTempA_H
	movlw	5
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	SysCalcTempX_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movf	SOUNDPLAYNOTELEN,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	SysTemp2
	movf	SysCalcTempA_H,W
	movwf	SysTemp2_H
	movf	SysTemp2,W
	movwf	SysCalcTempA
	movf	SysTemp2_H,W
	movwf	SysCalcTempA_H
	movf	SOUNDPLAYPERIOD,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	SysTemp1
	movf	SysCalcTempA_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	10
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	SOUNDPLAYCYCLES
	movf	SysCalcTempX_H,W
	movwf	SOUNDPLAYCYCLES_H
;End If
ENDIF36
;If SoundPlayNote <= 24 Then
	movf	SOUNDPLAYNOTE,W
	sublw	24
	btfss	STATUS, C
	goto	ELSE37_1
;Repeat SoundPlayCycles
	movf	SOUNDPLAYCYCLES,W
	movwf	SysRepeatTemp1
	movlw	1
	addwf	SOUNDPLAYCYCLES_H,W
	movwf	SysRepeatTemp1_H
	movf	SysRepeatTemp1,W
	movwf	SysCalcTempA
	movf	SysRepeatTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	1
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysRepeatLoopEnd1
SysRepeatLoop1
;Set SOUNDOUT On
	bsf	GPIO,0
;Repeat SoundPlayPeriod
	movf	SOUNDPLAYPERIOD,W
	movwf	SysRepeatTemp2
	btfsc	STATUS,Z
	goto	SysRepeatLoopEnd2
SysRepeatLoop2
;Wait 40 us
	movlw	26
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
	nop
;End Repeat
	decfsz	SysRepeatTemp2,F
	goto	SysRepeatLoop2
SysRepeatLoopEnd2
;Set SOUNDOUT Off
	bcf	GPIO,0
;Repeat SoundPlayPeriod
	movf	SOUNDPLAYPERIOD,W
	movwf	SysRepeatTemp2
	btfsc	STATUS,Z
	goto	SysRepeatLoopEnd3
SysRepeatLoop3
;Wait 40 us
	movlw	26
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	nop
;End Repeat
	decfsz	SysRepeatTemp2,F
	goto	SysRepeatLoop3
SysRepeatLoopEnd3
;End Repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop1
	decfsz	SysRepeatTemp1_H,F
	goto	SysRepeatLoop1
SysRepeatLoopEnd1
;Else
	goto	ENDIF37
ELSE37_1
;Repeat SoundPlayCycles
	movf	SOUNDPLAYCYCLES,W
	movwf	SysRepeatTemp1
	movlw	1
	addwf	SOUNDPLAYCYCLES_H,W
	movwf	SysRepeatTemp1_H
	movf	SysRepeatTemp1,W
	movwf	SysCalcTempA
	movf	SysRepeatTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	1
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysRepeatLoopEnd4
SysRepeatLoop4
;PulseOut SOUNDOUT, SoundPlayPeriod 10us
;Set Pin On
	bsf	GPIO,0
;Wait Time
	movf	SOUNDPLAYPERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set Pin Off
	bcf	GPIO,0
;Wait SoundPlayPeriod 10us
	movf	SOUNDPLAYPERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;End Repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop4
	decfsz	SysRepeatTemp1_H,F
	goto	SysRepeatLoop4
SysRepeatLoopEnd4
;End If
ENDIF37
;End If
ENDIF34
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA_H,W
	movf	SYSCALCTEMPA_H,W
;subwf SysCalcTempB_H,W
	subwf	SYSCALCTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;movf SysCalcTempB_H,W
	movf	SYSCALCTEMPB_H,W
;subwf SysCalcTempA_H,W
	subwf	SYSCALCTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;movf SysCalcTempB,W
	movf	SYSCALCTEMPB,W
;subwf SysCalcTempA,W
	subwf	SYSCALCTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF50
;SysCalcTempA = 0
	clrf	SYSCALCTEMPA
	clrf	SYSCALCTEMPA_H
;exit sub
	return
;end if
ENDIF50
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	addlw	1
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF51
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF51
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysCalcTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSCALCTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSCALCTEMPA_H
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

SYSMULTSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
MUL8LOOP
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;btfsc SysCalcTempB, 0
	btfsc	SYSCALCTEMPB, 0
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
;bcf STATUS, C
	bcf	STATUS, C
;rrf SysCalcTempB, F
	rrf	SYSCALCTEMPB, F
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;movf SysCalcTempB, F
	movf	SYSCALCTEMPB, F
;btfss STATUS, Z
	btfss	STATUS, Z
;goto MUL8LOOP
	goto	MUL8LOOP
	return

;********************************************************************************

SYSMULTSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
MUL16LOOP
;IF SysDivMultB.0 ON then SysDivMultX += SysDivMultA
	btfss	SYSDIVMULTB,0
	goto	ENDIF48
	movf	SYSDIVMULTA,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTA_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
ENDIF48
;set STATUS.C OFF
	bcf	STATUS,C
;rotate SysDivMultB right
	rrf	SYSDIVMULTB_H,F
	rrf	SYSDIVMULTB,F
;set STATUS.C off
	bcf	STATUS,C
;rotate SysDivMultA left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;if SysDivMultB > 0 then goto MUL16LOOP
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempB
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempB_H
	clrf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	MUL16LOOP
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

SYSREADSTRING
;Dim SysCalcTempA As Byte
;Dim SysStringLength As Byte
;movf SysStringB, W
	movf	SYSSTRINGB, W
;movwf FSR
	movwf	FSR
;bcf STATUS, IRP
	bcf	STATUS, IRP
;btfsc SysStringB_H, 0
	btfsc	SYSSTRINGB_H, 0
;bsf STATUS, IRP
	bsf	STATUS, IRP
;call SysStringTables
	call	SYSSTRINGTABLES
;movwf SysCalcTempA
	movwf	SYSCALCTEMPA
;movwf INDF
	movwf	INDF
;addwf SysStringB, F
	addwf	SYSSTRINGB, F
;goto SysStringReadCheck
	goto	SYSSTRINGREADCHECK
SYSREADSTRINGPART
;movf SysStringB, W
	movf	SYSSTRINGB, W
;movwf FSR
	movwf	FSR
;decf FSR,F
;bcf STATUS, IRP
	bcf	STATUS, IRP
;btfsc SysStringB_H, 0
	btfsc	SYSSTRINGB_H, 0
;bsf STATUS, IRP
	bsf	STATUS, IRP
;call SysStringTables
	call	SYSSTRINGTABLES
;movwf SysCalcTempA
	movwf	SYSCALCTEMPA
;addwf SysStringLength,F
	addwf	SYSSTRINGLENGTH,F
;addwf SysStringB,F
	addwf	SYSSTRINGB,F
SYSSTRINGREADCHECK
;movf SysCalcTempA,F
	movf	SYSCALCTEMPA,F
;btfsc STATUS,Z
	btfsc	STATUS,Z
;return
	return
SYSSTRINGREAD
;call SysStringTables
	call	SYSSTRINGTABLES
;incf FSR, F
	incf	FSR, F
;movwf INDF
	movwf	INDF
;decfsz SysCalcTempA, F
	decfsz	SYSCALCTEMPA, F
;goto SysStringRead
	goto	SYSSTRINGREAD
	return

;********************************************************************************

SysStringTables
	movf	SysStringA_H,W
	movwf	PCLATH
	movf	SysStringA,W
	incf	SysStringA,F
	btfsc	STATUS,Z
	incf	SysStringA_H,F
	movwf	PCL

StringTable1
	retlw	4
	retlw	84	;T
	retlw	50	;2
	retlw	52	;4
	retlw	48	;0


StringTable2
	retlw	19
	retlw	79	;O
	retlw	49	;1
	retlw	67	;C
	retlw	50	;2
	retlw	79	;O
	retlw	48	;0
	retlw	66	;B
	retlw	52	;4
	retlw	46	;.
	retlw	79	;O
	retlw	49	;1
	retlw	67	;C
	retlw	56	;8
	retlw	79	;O
	retlw	48	;0
	retlw	65	;A
	retlw	52	;4
	retlw	79	;O
	retlw	49	;1


StringTable3
	retlw	18
	retlw	67	;C
	retlw	50	;2
	retlw	68	;D
	retlw	52	;4
	retlw	69	;E
	retlw	45	;-
	retlw	52	;4
	retlw	69	;E
	retlw	52	;4
	retlw	70	;F
	retlw	52	;4
	retlw	70	;F
	retlw	35	;#
	retlw	52	;4
	retlw	71	;G
	retlw	52	;4
	retlw	80	;P
	retlw	52	;4


StringTable4
	retlw	18
	retlw	79	;O
	retlw	48	;0
	retlw	71	;G
	retlw	50	;2
	retlw	79	;O
	retlw	51	;3
	retlw	69	;E
	retlw	52	;4
	retlw	80	;P
	retlw	56	;8
	retlw	69	;E
	retlw	56	;8
	retlw	69	;E
	retlw	52	;4
	retlw	69	;E
	retlw	52	;4
	retlw	69	;E
	retlw	52	;4


StringTable5
	retlw	18
	retlw	56	;8
	retlw	69	;E
	retlw	56	;8
	retlw	70	;F
	retlw	52	;4
	retlw	70	;F
	retlw	52	;4
	retlw	68	;D
	retlw	56	;8
	retlw	67	;C
	retlw	35	;#
	retlw	56	;8
	retlw	68	;D
	retlw	56	;8
	retlw	69	;E
	retlw	56	;8
	retlw	68	;D
	retlw	52	;4


StringTable6
	retlw	19
	retlw	68	;D
	retlw	52	;4
	retlw	79	;O
	retlw	51	;3
	retlw	67	;C
	retlw	51	;3
	retlw	50	;2
	retlw	79	;O
	retlw	50	;2
	retlw	66	;B
	retlw	49	;1
	retlw	54	;6
	retlw	46	;.
	retlw	66	;B
	retlw	56	;8
	retlw	65	;A
	retlw	52	;4
	retlw	66	;B
	retlw	52	;4


StringTable7
	retlw	18
	retlw	71	;G
	retlw	52	;4
	retlw	79	;O
	retlw	51	;3
	retlw	71	;G
	retlw	52	;4
	retlw	80	;P
	retlw	56	;8
	retlw	71	;G
	retlw	56	;8
	retlw	71	;G
	retlw	52	;4
	retlw	71	;G
	retlw	52	;4
	retlw	79	;O
	retlw	51	;3
	retlw	71	;G
	retlw	52	;4


StringTable8
	retlw	19
	retlw	80	;P
	retlw	56	;8
	retlw	71	;G
	retlw	56	;8
	retlw	71	;G
	retlw	35	;#
	retlw	52	;4
	retlw	71	;G
	retlw	35	;#
	retlw	52	;4
	retlw	65	;A
	retlw	56	;8
	retlw	71	;G
	retlw	35	;#
	retlw	56	;8
	retlw	65	;A
	retlw	56	;8
	retlw	79	;O
	retlw	52	;4


StringTable9
	retlw	19
	retlw	67	;C
	retlw	56	;8
	retlw	79	;O
	retlw	51	;3
	retlw	66	;B
	retlw	52	;4
	retlw	65	;A
	retlw	52	;4
	retlw	71	;G
	retlw	35	;#
	retlw	50	;2
	retlw	46	;.
	retlw	79	;O
	retlw	51	;3
	retlw	71	;G
	retlw	35	;#
	retlw	52	;4
	retlw	71	;G
	retlw	52	;4


StringTable10
	retlw	19
	retlw	80	;P
	retlw	56	;8
	retlw	71	;G
	retlw	56	;8
	retlw	79	;O
	retlw	52	;4
	retlw	67	;C
	retlw	52	;4
	retlw	80	;P
	retlw	56	;8
	retlw	79	;O
	retlw	51	;3
	retlw	65	;A
	retlw	56	;8
	retlw	71	;G
	retlw	52	;4
	retlw	70	;F
	retlw	35	;#
	retlw	52	;4


StringTable11
	retlw	19
	retlw	71	;G
	retlw	52	;4
	retlw	69	;E
	retlw	52	;4
	retlw	68	;D
	retlw	52	;4
	retlw	79	;O
	retlw	50	;2
	retlw	71	;G
	retlw	56	;8
	retlw	70	;F
	retlw	35	;#
	retlw	56	;8
	retlw	71	;G
	retlw	52	;4
	retlw	79	;O
	retlw	51	;3
	retlw	68	;D
	retlw	52	;4


StringTable12
	retlw	19
	retlw	79	;O
	retlw	50	;2
	retlw	71	;G
	retlw	56	;8
	retlw	70	;F
	retlw	35	;#
	retlw	56	;8
	retlw	71	;G
	retlw	52	;4
	retlw	79	;O
	retlw	51	;3
	retlw	79	;O
	retlw	51	;3
	retlw	71	;G
	retlw	52	;4
	retlw	80	;P
	retlw	56	;8
	retlw	71	;G
	retlw	56	;8


StringTable13
	retlw	17
	retlw	79	;O
	retlw	52	;4
	retlw	67	;C
	retlw	52	;4
	retlw	80	;P
	retlw	56	;8
	retlw	79	;O
	retlw	51	;3
	retlw	65	;A
	retlw	56	;8
	retlw	71	;G
	retlw	52	;4
	retlw	70	;F
	retlw	35	;#
	retlw	52	;4
	retlw	71	;G
	retlw	52	;4


StringTable14
	retlw	17
	retlw	69	;E
	retlw	45	;-
	retlw	52	;4
	retlw	68	;D
	retlw	52	;4
	retlw	79	;O
	retlw	50	;2
	retlw	70	;F
	retlw	35	;#
	retlw	56	;8
	retlw	69	;E
	retlw	56	;8
	retlw	70	;F
	retlw	35	;#
	retlw	56	;8
	retlw	69	;E
	retlw	56	;8


StringTable15
	retlw	19
	retlw	70	;F
	retlw	35	;#
	retlw	52	;4
	retlw	71	;G
	retlw	52	;4
	retlw	80	;P
	retlw	52	;4
	retlw	71	;G
	retlw	52	;4
	retlw	46	;.
	retlw	70	;F
	retlw	56	;8
	retlw	69	;E
	retlw	50	;2
	retlw	65	;A
	retlw	52	;4
	retlw	46	;.
	retlw	71	;G
	retlw	56	;8


StringTable16
	retlw	19
	retlw	79	;O
	retlw	49	;1
	retlw	66	;B
	retlw	50	;2
	retlw	65	;A
	retlw	50	;2
	retlw	79	;O
	retlw	49	;1
	retlw	71	;G
	retlw	50	;2
	retlw	79	;O
	retlw	50	;2
	retlw	70	;F
	retlw	50	;2
	retlw	69	;E
	retlw	50	;2
	retlw	68	;D
	retlw	52	;4
	retlw	46	;.


StringTable17
	retlw	18
	retlw	69	;E
	retlw	56	;8
	retlw	70	;F
	retlw	52	;4
	retlw	65	;A
	retlw	50	;2
	retlw	79	;O
	retlw	51	;3
	retlw	67	;C
	retlw	52	;4
	retlw	68	;D
	retlw	50	;2
	retlw	67	;C
	retlw	50	;2
	retlw	79	;O
	retlw	50	;2
	retlw	69	;E
	retlw	49	;1


StringTable18
	retlw	18
	retlw	68	;D
	retlw	50	;2
	retlw	79	;O
	retlw	51	;3
	retlw	71	;G
	retlw	52	;4
	retlw	46	;.
	retlw	70	;F
	retlw	56	;8
	retlw	69	;E
	retlw	50	;2
	retlw	65	;A
	retlw	52	;4
	retlw	46	;.
	retlw	71	;G
	retlw	56	;8
	retlw	79	;O
	retlw	50	;2


StringTable19
	retlw	19
	retlw	66	;B
	retlw	50	;2
	retlw	65	;A
	retlw	50	;2
	retlw	71	;G
	retlw	50	;2
	retlw	79	;O
	retlw	51	;3
	retlw	70	;F
	retlw	50	;2
	retlw	69	;E
	retlw	50	;2
	retlw	68	;D
	retlw	52	;4
	retlw	46	;.
	retlw	69	;E
	retlw	56	;8
	retlw	70	;F
	retlw	52	;4


StringTable20
	retlw	18
	retlw	65	;A
	retlw	52	;4
	retlw	79	;O
	retlw	52	;4
	retlw	68	;D
	retlw	52	;4
	retlw	46	;.
	retlw	67	;C
	retlw	56	;8
	retlw	79	;O
	retlw	51	;3
	retlw	69	;E
	retlw	52	;4
	retlw	71	;G
	retlw	52	;4
	retlw	67	;C
	retlw	52	;4
	retlw	46	;.


StringTable21
	retlw	6
	retlw	69	;E
	retlw	56	;8
	retlw	68	;D
	retlw	49	;1
	retlw	67	;C
	retlw	49	;1


StringTable22
	retlw	1
	retlw	97	;a


StringTable23
	retlw	1
	retlw	122	;z


StringTable24
	retlw	1
	retlw	65	;A


StringTable25
	retlw	1
	retlw	71	;G


StringTable26
	retlw	1
	retlw	80	;P


StringTable27
	retlw	1
	retlw	78	;N


StringTable28
	retlw	1
	retlw	76	;L


StringTable29
	retlw	1
	retlw	84	;T


StringTable30
	retlw	1
	retlw	79	;O


StringTable31
	retlw	1
	retlw	60	;<


StringTable32
	retlw	1
	retlw	62	;>


StringTable33
	retlw	1
	retlw	48	;0


StringTable34
	retlw	1
	retlw	57	;9


StringTable35
	retlw	1
	retlw	35	;#


StringTable36
	retlw	1
	retlw	43	;+


StringTable37
	retlw	1
	retlw	45	;-


StringTable38
	retlw	1
	retlw	46	;.


;********************************************************************************


 END
