;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSCALCTEMPA	EQU	117
SYSSTRINGLENGTH	EQU	118
SysStringA	EQU	119
SysStringA_H	EQU	120
SysStringB	EQU	114
SysStringB_H	EQU	115
SysWaitTempUS	EQU	117
SysWaitTempUS_H	EQU	118
SYSSTRINGPARAM1	EQU	169
I	EQU	32
NUMBER	EQU	33
PATTERN	EQU	34
PRINTLEN	EQU	35
RXHIGHCOUNT	EQU	36
SERBIT	EQU	37
SERBITSAMPLE	EQU	38
SERDELAYLOOP	EQU	39
SERQUICKSAMPLE	EQU	40
SERTEMP	EQU	41
SER_BYTE	EQU	42
SER_DATA	EQU	43
SER_DATA_A	EQU	44
SER_INVERT	EQU	45
SER_INVERT_A	EQU	46
SER_PARITY	EQU	47
SER_PARITY_A	EQU	48
SER_RATE	EQU	49
SER_RATE_A	EQU	50
SER_SELECT	EQU	51
SER_SELECT_OLD	EQU	52
SER_START	EQU	53
SER_START_A	EQU	54
SER_STOP	EQU	55
SER_STOP_A	EQU	56
SYSPRINTTEMP	EQU	57
StringPointer	EQU	58
SysPRINTDATAHandler	EQU	59
SysPRINTDATAHandler_H	EQU	60
SysTemp1	EQU	61
TEMPPARITY	EQU	62

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;Control four LEDs from a PC via serial communication.
;Connect GP0 through GP2 and GP5 to LED1 through LED4,
;respectively. Connect GP3 to Rx and GP4 to Tx. Connect
;a PC to the DB-9. Use a USB-to-COM adapter if needed.
;Test the unit with any terminal program.
;Note: Software serial communication is used here. The
;baud rate is 4800.
;----- Settings
;----- Constants
;#define SerInPort		GPIO.3            ;Rx input on pin 4
;#define SerOutPort	GPIO.4            ;Tx output on pin 3
;#define LED1				GPIO.0  					;pin 7
;#define LED2				GPIO.1						;pin 6
;#define LED3				GPIO.2						;pin 5
;#define LED4				GPIO.5						;pin 2
;#define SendAHigh Set SerOutPort  on  ;output logic levels
;#define SendALow  Set SerOutPort  off
;#define RecAHigh  SerInPort       on  ;input logic levels
;#define RecALow   SerInPort       off
;#define ASCIIZero 48                  ;ASCII value of '0'
;#define cr 13                         ;carriage return
;#define lf 10                         ;line feed
;----- Variables
;dim pattern, number, i as byte
;----- Program
;dir GPIO out   											;most pins are outputs
	banksel	TRISIO
	clrf	TRISIO
;dir SerInPort in                    ;except for this one
	bsf	TRISIO,3
;InitSer 1, r4800, 1+WaitForStart, 8, 1, none, invert
	movlw	1
	banksel	SER_SELECT
	movwf	SER_SELECT
	movlw	4
	movwf	SER_RATE
	movlw	129
	movwf	SER_START
	movlw	8
	movwf	SER_DATA
	movlw	1
	movwf	SER_STOP
	clrf	SER_PARITY
	movlw	1
	movwf	SER_INVERT
	call	INITSER
;do
SysDoLoop_S1
;SerPrint 1, "LED to light (1-4): "
	movlw	1
	movwf	SER_SELECT
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable1
	movwf	SysStringA
	movlw	high StringTable1
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler_H
	call	SERPRINT13
;SerSend 1, cr
	movlw	1
	movwf	SER_SELECT
	movlw	13
	movwf	SER_BYTE
	call	SERSEND
;SerSend 1, lf
	movlw	1
	movwf	SER_SELECT
	movlw	10
	movwf	SER_BYTE
	call	SERSEND
;SerReceive 1, number              ;get LED number in ASCII
	movlw	1
	movwf	SER_SELECT
	call	SERRECEIVE
	movf	SER_BYTE,W
	movwf	NUMBER
;SerPrint 1, "LED Chosen: "        ;echo to terminal
	movlw	1
	movwf	SER_SELECT
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable2
	movwf	SysStringA
	movlw	high StringTable2
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler_H
	call	SERPRINT13
;SerSend 1, number
	movlw	1
	movwf	SER_SELECT
	movf	NUMBER,W
	movwf	SER_BYTE
	call	SERSEND
;SerSend 1, cr
	movlw	1
	movwf	SER_SELECT
	movlw	13
	movwf	SER_BYTE
	call	SERSEND
;SerSend 1, lf
	movlw	1
	movwf	SER_SELECT
	movlw	10
	movwf	SER_BYTE
	call	SERSEND
;number = number - ASCIIZero      	;convert from ASCII to number
	movlw	48
	subwf	NUMBER,F
;pattern = 0                       ;now extract which LED to light
	clrf	PATTERN
;status.c = 1                      ;set the carry flag
	bsf	STATUS,C
;for i = 1 to number               ;rotate to correct position
	clrf	I
	movlw	1
	subwf	NUMBER,W
	btfss	STATUS, C
	goto	SysForLoopEnd1
SysForLoop1
	incf	I,F
;rotate pattern left
	rlf	PATTERN,F
;next i
	movf	NUMBER,W
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;set LED1 off											;first turn off all LEDs
	bcf	GPIO,0
;set LED2 off
	bcf	GPIO,1
;set LED3 off
	bcf	GPIO,2
;set LED4 off
	bcf	GPIO,5
;LED1 = pattern.0                  ;then light the requested one
	bcf	GPIO,0
	btfsc	PATTERN,0
	bsf	GPIO,0
;LED2 = pattern.1
	bcf	GPIO,1
	btfsc	PATTERN,1
	bsf	GPIO,1
;LED3 = pattern.2
	bcf	GPIO,2
	btfsc	PATTERN,2
	bsf	GPIO,2
;LED4 = pattern.3
	bcf	GPIO,5
	btfsc	PATTERN,3
	bsf	GPIO,5
;loop                          			;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

INITSER
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF3
;Ser_Rate_A = Ser_Rate
	movf	SER_RATE,W
	movwf	SER_RATE_A
;Ser_Start_A = Ser_Start
	movf	SER_START,W
	movwf	SER_START_A
;Ser_Data_A = Ser_Data
	movf	SER_DATA,W
	movwf	SER_DATA_A
;Ser_Stop_A = Ser_Stop
	movf	SER_STOP,W
	movwf	SER_STOP_A
;Ser_Parity_A = Ser_Parity
	movf	SER_PARITY,W
	movwf	SER_PARITY_A
;Ser_Invert_A = Ser_Invert
	movf	SER_INVERT,W
	movwf	SER_INVERT_A
;END IF
ENDIF3
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SERBITDELAY
;if Ser_Rate = 1 then Wait SerFullDelay19200 us: exit sub	'19200 (52 us)
	decf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF52
	movlw	19
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
	return
ENDIF52
;if Ser_Rate = 2 then Wait SerFullDelay9600 us: exit sub 	'9600 (104 us)
	movlw	2
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF53
	movlw	52
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	nop
	return
ENDIF53
;if Ser_Rate = 4 then Wait SerFullDelay4800 us: exit sub 	'4800 (208 us)
	movlw	4
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF54
	movlw	122
	movwf	DELAYTEMP
DelayUS3
	decfsz	DELAYTEMP,F
	goto	DelayUS3
	return
ENDIF54
;if Ser_Rate = 8 then Wait SerFullDelay2400 us: exit sub 	'2400 (417 us)
	movlw	8
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF55
	movlw	1
	movwf	DELAYTEMP2
DelayUSO4
	clrf	DELAYTEMP
DelayUS4
	decfsz	DELAYTEMP,F
	goto	DelayUS4
	decfsz	DELAYTEMP2,F
	goto	DelayUSO4
	movlw	4
	movwf	DELAYTEMP
DelayUS5
	decfsz	DELAYTEMP,F
	goto	DelayUS5
	return
ENDIF55
;if Ser_Rate = 16 then Wait SerFullDelay1200 us: exit sub 	'1200 (833 us)
	movlw	16
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF56
	movlw	2
	movwf	DELAYTEMP2
DelayUSO6
	clrf	DELAYTEMP
DelayUS6
	decfsz	DELAYTEMP,F
	goto	DelayUS6
	decfsz	DELAYTEMP2,F
	goto	DelayUSO6
	movlw	24
	movwf	DELAYTEMP
DelayUS7
	decfsz	DELAYTEMP,F
	goto	DelayUS7
	return
ENDIF56
;if Ser_Rate = 32 then Wait SerFullDelay600 us: exit sub 	'600 (1666 us)
	movlw	32
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF57
	movlw	4
	movwf	DELAYTEMP2
DelayUSO8
	clrf	DELAYTEMP
DelayUS8
	decfsz	DELAYTEMP,F
	goto	DelayUS8
	decfsz	DELAYTEMP2,F
	goto	DelayUSO8
	movlw	65
	movwf	DELAYTEMP
DelayUS9
	decfsz	DELAYTEMP,F
	goto	DelayUS9
	nop
	return
ENDIF57
;if Ser_Rate = 64 then Wait SerFullDelay300 us: exit sub '300 (3333 us)
	movlw	64
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF58
	movlw	8
	movwf	DELAYTEMP2
DelayUSO10
	clrf	DELAYTEMP
DelayUS10
	decfsz	DELAYTEMP,F
	goto	DelayUS10
	decfsz	DELAYTEMP2,F
	goto	DelayUSO10
	movlw	149
	movwf	DELAYTEMP
DelayUS11
	decfsz	DELAYTEMP,F
	goto	DelayUS11
	return
ENDIF58
;for SerDelayLoop = 1 to Ser_Rate
	clrf	SERDELAYLOOP
	movlw	1
	subwf	SER_RATE,W
	btfss	STATUS, C
	goto	SysForLoopEnd10
SysForLoop10
	incf	SERDELAYLOOP,F
;Wait 42 us
	movlw	28
	movwf	DELAYTEMP
DelayUS12
	decfsz	DELAYTEMP,F
	goto	DelayUS12
;next
	movf	SER_RATE,W
	subwf	SERDELAYLOOP,W
	btfss	STATUS, C
	goto	SysForLoop10
SysForLoopEnd10
	return

;********************************************************************************

SERCFGLOAD
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF51
;Ser_Rate = Ser_Rate_A
	movf	SER_RATE_A,W
	movwf	SER_RATE
;Ser_Start = Ser_Start_A
	movf	SER_START_A,W
	movwf	SER_START
;Ser_Data = Ser_Data_A
	movf	SER_DATA_A,W
	movwf	SER_DATA
;Ser_Stop = Ser_Stop_A
	movf	SER_STOP_A,W
	movwf	SER_STOP
;Ser_Parity = Ser_Parity_A
	movf	SER_PARITY_A,W
	movwf	SER_PARITY
;Ser_Invert = Ser_Invert_A
	movf	SER_INVERT_A,W
	movwf	SER_INVERT
;end if
ENDIF51
	return

;********************************************************************************

;Overloaded signature: BYTE:STRING:
SERPRINT13
;PrintLen = PrintData(0)
	movf	SysPRINTDATAHandler,W
	movwf	FSR
	bcf	STATUS, IRP
	btfsc	SysPRINTDATAHandler_H,0
	bsf	STATUS, IRP
	movf	INDF,W
	movwf	PRINTLEN
;if PrintLen = 0 then Goto SerPrintStrEnd
	movf	PRINTLEN,F
	btfsc	STATUS, Z
	goto	SERPRINTSTREND
;for SysPrintTemp = 1 to PrintLen
	clrf	SYSPRINTTEMP
	movlw	1
	subwf	PRINTLEN,W
	btfss	STATUS, C
	goto	SysForLoopEnd8
SysForLoop8
	incf	SYSPRINTTEMP,F
;SerSend(Ser_Select, PrintData(SysPrintTemp))
	movf	SYSPRINTTEMP,W
	addwf	SysPRINTDATAHandler,W
	movwf	FSR
	bcf	STATUS, IRP
	btfsc	SysPRINTDATAHandler_H,0
	bsf	STATUS, IRP
	movf	INDF,W
	movwf	SER_BYTE
	call	SERSEND
;next
	movf	PRINTLEN,W
	subwf	SYSPRINTTEMP,W
	btfss	STATUS, C
	goto	SysForLoop8
SysForLoopEnd8
SERPRINTSTREND
	return

;********************************************************************************

FN_SERQUICKSAMPLE
;SerQuickSample = FALSE
	clrf	SERQUICKSAMPLE
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF49
;if RecAHigh then SerQuickSample = TRUE
	btfss	GPIO,3
	goto	ENDIF50
	movlw	255
	movwf	SERQUICKSAMPLE
ENDIF50
;end if
ENDIF49
	return

;********************************************************************************

SERRECEIVE
;if Ser_Select <> Ser_Select_Old then SerCfgLoad(Ser_Select)
	movf	SER_SELECT_OLD,W
	subwf	SER_SELECT,W
	btfss	STATUS, Z
	call	SERCFGLOAD
;If Ser_Start.7 = On Then
	btfss	SER_START,7
	goto	ELSE31_1
;Wait Until SerQuickSample = TRUE
SysWaitLoop1
	call	FN_SERQUICKSAMPLE
	incf	SERQUICKSAMPLE,W
	btfss	STATUS, Z
	goto	SysWaitLoop1
;Else
	goto	ENDIF31
ELSE31_1
;If SerQuickSample = False Then Exit Sub
	call	FN_SERQUICKSAMPLE
	movf	SERQUICKSAMPLE,F
	btfsc	STATUS, Z
	return
;End If
ENDIF31
;IntOff
;SerTemp = Ser_Start and (not WaitForStart)
	movlw	127
	andwf	SER_START,W
	movwf	SERTEMP
;for SerBit = 1 to SerTemp
	clrf	SERBIT
	movlw	1
	subwf	SERTEMP,W
	btfss	STATUS, C
	goto	SysForLoopEnd5
SysForLoop5
	incf	SERBIT,F
;SerRxBit
	call	SERRXBIT
;next
	movf	SERTEMP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop5
SysForLoopEnd5
;Ser_Byte = 0
	clrf	SER_BYTE
;for SerBit = 1 to Ser_Data
	clrf	SERBIT
	movlw	1
	subwf	SER_DATA,W
	btfss	STATUS, C
	goto	SysForLoopEnd6
SysForLoop6
	incf	SERBIT,F
;SerRxBit
	call	SERRXBIT
;Rotate Ser_Byte Right
	rrf	SER_BYTE,F
;next
	movf	SER_DATA,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop6
SysForLoopEnd6
;if Ser_Data < 8 then
	movlw	8
	subwf	SER_DATA,W
	btfsc	STATUS, C
	goto	ENDIF36
;for SerBit = Ser_Data to 8
	decf	SER_DATA,W
	movwf	SERBIT
	movf	SER_DATA,W
	sublw	8
	btfss	STATUS, C
	goto	SysForLoopEnd7
SysForLoop7
	incf	SERBIT,F
;Set C Off
	bcf	STATUS,C
;ROTATE Ser_Byte RIGHT
	rrf	SER_BYTE,F
;next
	movlw	8
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop7
SysForLoopEnd7
;end if
ENDIF36
;if Ser_Invert = invert then Ser_Byte = !Ser_Byte
	decf	SER_INVERT,W
	btfsc	STATUS, Z
	comf	SER_BYTE,F
;if Ser_Parity <> 0 THEN
	movf	SER_PARITY,F
	btfsc	STATUS, Z
	goto	ENDIF38
;TempParity = 0
	clrf	TEMPPARITY
;SerRxBit
	call	SERRXBIT
;end if
ENDIF38
;Wait Until SerQuickSample = FALSE
SysWaitLoop2
	call	FN_SERQUICKSAMPLE
	movf	SERQUICKSAMPLE,F
	btfss	STATUS, Z
	goto	SysWaitLoop2
;IntOn
	return

;********************************************************************************

SERRXBIT
;RxHighCount = 0
	clrf	RXHIGHCOUNT
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF45
;for SerBitSample = 1 to 3
	clrf	SERBITSAMPLE
SysForLoop9
	incf	SERBITSAMPLE,F
;if RecAHigh then RxHighCount = RxHighCount + 1
	btfsc	GPIO,3
	incf	RXHIGHCOUNT,F
;SerThirdBitDelay
	call	SERTHIRDBITDELAY
;next
	movlw	3
	subwf	SERBITSAMPLE,W
	btfss	STATUS, C
	goto	SysForLoop9
SysForLoopEnd9
;end if
ENDIF45
;SET C OFF
	bcf	STATUS,C
;If RxHighCount.1 = ON Then SET C ON
	btfsc	RXHIGHCOUNT,1
	bsf	STATUS,C
	return

;********************************************************************************

SERSEND
;if Ser_Select <> Ser_Select_Old then SerCfgLoad(Ser_Select)
	movf	SER_SELECT_OLD,W
	subwf	SER_SELECT,W
	btfss	STATUS, Z
	call	SERCFGLOAD
;SerTemp = Ser_Start and (not WaitForStart)
	movlw	127
	andwf	SER_START,W
	movwf	SERTEMP
;for SerBit = 1 to SerTemp
	clrf	SERBIT
	movlw	1
	subwf	SERTEMP,W
	btfss	STATUS, C
	goto	SysForLoopEnd2
SysForLoop2
	incf	SERBIT,F
;SerTxHigh
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,4
;SerBitDelay
	call	SERBITDELAY
;next
	movf	SERTEMP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;TempParity = SerTemp
	movf	SERTEMP,W
	movwf	TEMPPARITY
;for SerBit = 1 to Ser_Data
	clrf	SERBIT
	movlw	1
	subwf	SER_DATA,W
	btfss	STATUS, C
	goto	SysForLoopEnd3
SysForLoop3
	incf	SERBIT,F
;if Ser_Invert = normal then
	movf	SER_INVERT,F
	btfss	STATUS, Z
	goto	ENDIF9
;if Ser_Byte.0 ON then SerTxHigh: TempParity = TempParity + 1
	btfss	SER_BYTE,0
	goto	ENDIF16
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,4
;SerBitDelay
	call	SERBITDELAY
	incf	TEMPPARITY,F
ENDIF16
;if Ser_Byte.0 OFF then SerTxLow
	btfsc	SER_BYTE,0
	goto	ENDIF17
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,4
;SerBitDelay
	call	SERBITDELAY
ENDIF17
;end if
ENDIF9
;if Ser_Invert = invert then
	decf	SER_INVERT,W
	btfss	STATUS, Z
	goto	ENDIF10
;if Ser_Byte.0 ON then SerTxLow: TempParity = TempParity + 1
	btfss	SER_BYTE,0
	goto	ENDIF18
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,4
;SerBitDelay
	call	SERBITDELAY
	incf	TEMPPARITY,F
ENDIF18
;if Ser_Byte.0 OFF then SerTxHigh
	btfsc	SER_BYTE,0
	goto	ENDIF19
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,4
;SerBitDelay
	call	SERBITDELAY
ENDIF19
;end if
ENDIF10
;rotate Ser_Byte right
	rrf	SER_BYTE,F
;next
	movf	SER_DATA,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;if Ser_Parity <> 0 THEN
	movf	SER_PARITY,F
	btfsc	STATUS, Z
	goto	ENDIF12
;if Ser_Parity = odd then TempParity = TempParity + 1
	decf	SER_PARITY,W
	btfsc	STATUS, Z
	incf	TEMPPARITY,F
;if Ser_Invert = invert then TempParity = TempParity + 1
	decf	SER_INVERT,W
	btfsc	STATUS, Z
	incf	TEMPPARITY,F
;if TempParity.0 = ON then SerTxLow
	btfss	TEMPPARITY,0
	goto	ENDIF22
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,4
;SerBitDelay
	call	SERBITDELAY
ENDIF22
;if TempParity.0 = OFF then SerTxHigh
	btfsc	TEMPPARITY,0
	goto	ENDIF23
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,4
;SerBitDelay
	call	SERBITDELAY
ENDIF23
;end if
ENDIF12
;for SerBit = 1 to Ser_Stop
	clrf	SERBIT
	movlw	1
	subwf	SER_STOP,W
	btfss	STATUS, C
	goto	SysForLoopEnd4
SysForLoop4
	incf	SERBIT,F
;SerTxLow
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,4
;SerBitDelay
	call	SERBITDELAY
;next
	movf	SER_STOP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
;SerBitDelay
	goto	SERBITDELAY

;********************************************************************************

SERTHIRDBITDELAY
;if Ser_Rate = 1 then Wait SerThirdDelay19200 us: exit sub	'19200 (17 us)
	decf	SER_RATE,W
	btfsc	STATUS, Z
	return
;if Ser_Rate = 2 then Wait SerThirdDelay9600 us: exit sub 	'9600 (35 us)
	movlw	2
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF62
	movlw	11
	movwf	DELAYTEMP
DelayUS13
	decfsz	DELAYTEMP,F
	goto	DelayUS13
	return
ENDIF62
;if Ser_Rate = 4 then Wait SerThirdDelay4800 us: exit sub 	'4800 (69 us)
	movlw	4
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF63
	movlw	34
	movwf	DELAYTEMP
DelayUS14
	decfsz	DELAYTEMP,F
	goto	DelayUS14
	return
ENDIF63
;if Ser_Rate = 8 then Wait SerThirdDelay2400 us: exit sub 	'2400 (139 us)
	movlw	8
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF64
	movlw	80
	movwf	DELAYTEMP
DelayUS15
	decfsz	DELAYTEMP,F
	goto	DelayUS15
	nop
	return
ENDIF64
;if Ser_Rate = 16 then Wait SerThirdDelay1200 us: exit sub 	'1200 (278 us)
	movlw	16
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF65
	movlw	173
	movwf	DELAYTEMP
DelayUS16
	decfsz	DELAYTEMP,F
	goto	DelayUS16
	return
ENDIF65
;if Ser_Rate = 32 then Wait SerThirdDelay600 us: exit sub 	'600 (555 us)
	movlw	32
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF66
	movlw	1
	movwf	DELAYTEMP2
DelayUSO17
	clrf	DELAYTEMP
DelayUS17
	decfsz	DELAYTEMP,F
	goto	DelayUS17
	decfsz	DELAYTEMP2,F
	goto	DelayUSO17
	movlw	100
	movwf	DELAYTEMP
DelayUS18
	decfsz	DELAYTEMP,F
	goto	DelayUS18
	nop
	return
ENDIF66
;if Ser_Rate = 64 then Wait SerThirdDelay300 us: exit sub	'300 (1111 us)
	movlw	64
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF67
	movlw	2
	movwf	DELAYTEMP2
DelayUSO19
	clrf	DELAYTEMP
DelayUS19
	decfsz	DELAYTEMP,F
	goto	DelayUS19
	decfsz	DELAYTEMP2,F
	goto	DelayUSO19
	movlw	214
	movwf	DELAYTEMP
DelayUS20
	decfsz	DELAYTEMP,F
	goto	DelayUS20
	return
ENDIF67
;for SerDelayLoop = 1 to Ser_Rate
	clrf	SERDELAYLOOP
	movlw	1
	subwf	SER_RATE,W
	btfss	STATUS, C
	goto	SysForLoopEnd11
SysForLoop11
	incf	SERDELAYLOOP,F
;Wait 13 us
	movlw	8
	movwf	DELAYTEMP
DelayUS21
	decfsz	DELAYTEMP,F
	goto	DelayUS21
	nop
;next
	movf	SER_RATE,W
	subwf	SERDELAYLOOP,W
	btfss	STATUS, C
	goto	SysForLoop11
SysForLoopEnd11
	return

;********************************************************************************

SYSREADSTRING
;Dim SysCalcTempA As Byte
;Dim SysStringLength As Byte
;movf SysStringB, W
	movf	SYSSTRINGB, W
;movwf FSR
	movwf	FSR
;bcf STATUS, IRP
	bcf	STATUS, IRP
;btfsc SysStringB_H, 0
	btfsc	SYSSTRINGB_H, 0
;bsf STATUS, IRP
	bsf	STATUS, IRP
;call SysStringTables
	call	SYSSTRINGTABLES
;movwf SysCalcTempA
	movwf	SYSCALCTEMPA
;movwf INDF
	movwf	INDF
;addwf SysStringB, F
	addwf	SYSSTRINGB, F
;goto SysStringReadCheck
	goto	SYSSTRINGREADCHECK
SYSREADSTRINGPART
;movf SysStringB, W
	movf	SYSSTRINGB, W
;movwf FSR
	movwf	FSR
;decf FSR,F
;bcf STATUS, IRP
	bcf	STATUS, IRP
;btfsc SysStringB_H, 0
	btfsc	SYSSTRINGB_H, 0
;bsf STATUS, IRP
	bsf	STATUS, IRP
;call SysStringTables
	call	SYSSTRINGTABLES
;movwf SysCalcTempA
	movwf	SYSCALCTEMPA
;addwf SysStringLength,F
	addwf	SYSSTRINGLENGTH,F
;addwf SysStringB,F
	addwf	SYSSTRINGB,F
SYSSTRINGREADCHECK
;movf SysCalcTempA,F
	movf	SYSCALCTEMPA,F
;btfsc STATUS,Z
	btfsc	STATUS,Z
;return
	return
SYSSTRINGREAD
;call SysStringTables
	call	SYSSTRINGTABLES
;incf FSR, F
	incf	FSR, F
;movwf INDF
	movwf	INDF
;decfsz SysCalcTempA, F
	decfsz	SYSCALCTEMPA, F
;goto SysStringRead
	goto	SYSSTRINGREAD
	return

;********************************************************************************

SysStringTables
	movf	SysStringA_H,W
	movwf	PCLATH
	movf	SysStringA,W
	incf	SysStringA,F
	btfsc	STATUS,Z
	incf	SysStringA_H,F
	movwf	PCL

StringTable1
	retlw	20
	retlw	76	;L
	retlw	69	;E
	retlw	68	;D
	retlw	32	; 
	retlw	116	;t
	retlw	111	;o
	retlw	32	; 
	retlw	108	;l
	retlw	105	;i
	retlw	103	;g
	retlw	104	;h
	retlw	116	;t
	retlw	32	; 
	retlw	40	;(
	retlw	49	;1
	retlw	45	;-
	retlw	52	;4
	retlw	41	;)
	retlw	58	;:
	retlw	32	; 


StringTable2
	retlw	12
	retlw	76	;L
	retlw	69	;E
	retlw	68	;D
	retlw	32	; 
	retlw	67	;C
	retlw	104	;h
	retlw	111	;o
	retlw	115	;s
	retlw	101	;e
	retlw	110	;n
	retlw	58	;:
	retlw	32	; 


;********************************************************************************


 END
