;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;This program demonstrates the comparator. Connect GPIO.1 to
;the potentiometer and GPIO.2 to LED1. The reference voltage
;is derived internally and is set at 2.5V. While monitoring
;the pot on the voltmeter, turn it up. The LED should remain
;off for voltages below 2,5V and turn on when above.
;----- Settings
;----- Constants
;#define compIn GPIO.1		;comparator input on pin 6
;#define compOut GPIO.2	;comparator output on pin 5
;----- Program
;dir GPIO 0b00000011			;set the port directions
	movlw	3
	banksel	TRISIO
	movwf	TRISIO
;CMCON0 = 0b00010011			;set up comparator
	movlw	19
	banksel	CMCON0
	movwf	CMCON0
;CMCON1 = 0b00000000
	clrf	CMCON1
;VRCON = 0b10001000			;set voltage reference to 2.5V
	movlw	136
	banksel	VRCON
	movwf	VRCON
;do											;just sit back and await the comparator!
SysDoLoop_S1
;loop										;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************


 END
